#ifndef LIBMONGO_H
#define LIBMONGO_H

#include <ffi.h>
#include <libio.h>
#include <time.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <bits/errno.h>
#include <unistd.h>

#undef _next
#undef _sbuf
#undef _pos
#undef _flags
#undef _IO_read_ptr
#undef _IO_read_end
#undef _IO_read_base
#undef _IO_write_base
#undef _IO_write_ptr
#undef _IO_write_end
#undef _IO_buf_base
#undef _IO_buf_end
#undef _IO_save_base
#undef _IO_backup_base
#undef _IO_save_end
#undef _markers
#undef _chain
#undef _fileno
#undef _flags2
#undef _old_offset
#undef _cur_column
#undef _vtable_offset
#undef _shortbuf
#undef _lock
#undef _offset
#undef __pad1
#undef __pad2
#undef __pad3
#undef __pad4
#undef __pad5
#undef _mode
#undef _unused2
#undef cur
#undef first
#undef data
#undef dataSize
#undef finished
#undef stack
#undef stackPos
#undef err
#undef errstr
#undef bytes
#undef ints
#undef i
#undef t
#undef len
#undef id
#undef responseTo
#undef op
#undef flag
#undef cursorID
#undef start
#undef num
#undef head
#undef fields
#undef objs
#undef host
#undef port
#undef next
#undef w
#undef wtimeout
#undef j
#undef fsync
#undef mode
#undef cmd
#undef seeds
#undef hosts
#undef name
#undef primary_connected
#undef primary
#undef replset
#undef sock
#undef flags
#undef conn_timeout_ms
#undef op_timeout_ms
#undef max_bson_size
#undef connected
#undef write_concern
#undef errcode
#undef lasterrcode
#undef lasterrstr
#undef reply
#undef conn
#undef ns
#undef seen
#undef current
#undef query
#undef options
#undef limit
#undef skip
#undef client
#undef dbname
#undef prefix
#undef files_ns
#undef chunks_ns
#undef gfs
#undef meta
#undef pos
#undef remote_name
#undef content_type
#undef length
#undef chunk_num
#undef pending_data
#undef pending_len
#undef count
#undef abcd
#undef buf
#undef tv_sec
#undef tv_usec
#undef iov_base
#undef iov_len
#undef sa_family
#undef sa_data
#undef msg_name
#undef msg_namelen
#undef msg_iov
#undef msg_iovlen
#undef msg_control
#undef msg_controllen
#undef msg_flags
#undef cmsg_len
#undef cmsg_level
#undef cmsg_type
#undef __cmsg_data
#undef __builtin_strcmp
#undef __builtin_strchr
#undef ai_flags
#undef ai_family
#undef ai_socktype
#undef ai_protocol
#undef ai_addrlen
#undef ai_addr
#undef ai_canonname
#undef ai_next
#undef strtol
#undef __nptr
#undef __endptr
#undef __base
#undef rand
#undef srand
#undef __seed
#undef malloc
#undef __size
#undef realloc
#undef __ptr
#undef free
#undef exit
#undef __status
#undef memcpy
#undef __dest
#undef __src
#undef __n
#undef strlen
#undef __s
#undef fprintf
#undef __stream
#undef __format
#undef printf
#undef sprintf
#undef vfprintf
#undef __arg
#undef time
#undef __timer
#undef strcpy
#undef strcat
#undef fclose
#undef fopen
#undef __filename
#undef __modes
#undef fread
#undef fwrite
#undef __builtin_strncpy
#undef memset
#undef __c
#undef strerror
#undef __errnum
#undef __errno_location
#undef socket
#undef __domain
#undef __type
#undef __protocol
#undef connect
#undef __fd
#undef __addr
#undef __len
#undef send
#undef __buf
#undef __flags
#undef recv
#undef setsockopt
#undef __level
#undef __optname
#undef __optval
#undef __optlen
#undef getaddrinfo
#undef __name
#undef __service
#undef __req
#undef __pai
#undef freeaddrinfo
#undef __ai
#undef gai_strerror
#undef __ecode
#undef close

enum PC_BSON_TYPE {
	BSON_EOO = 0,
	BSON_DOUBLE = 1,
	BSON_STRING = 2,
	BSON_OBJECT = 3,
	BSON_ARRAY = 4,
	BSON_BINDATA = 5,
	BSON_UNDEFINED = 6,
	BSON_OID = 7,
	BSON_BOOL = 8,
	BSON_DATE = 9,
	BSON_NULL = 10,
	BSON_REGEX = 11,
	BSON_DBREF = 12,
	BSON_CODE = 13,
	BSON_SYMBOL = 14,
	BSON_CODEWSCOPE = 15,
	BSON_INT = 16,
	BSON_TIMESTAMP = 17,
	BSON_LONG = 18
};
enum PC_MONGO_ERROR_T {
	MONGO_CONN_SUCCESS = 0,
	MONGO_CONN_NO_SOCKET = 1,
	MONGO_CONN_FAIL = 2,
	MONGO_CONN_ADDR_FAIL = 3,
	MONGO_CONN_NOT_MASTER = 4,
	MONGO_CONN_BAD_SET_NAME = 5,
	MONGO_CONN_NO_PRIMARY = 6,
	MONGO_IO_ERROR = 7,
	MONGO_SOCKET_ERROR = 8,
	MONGO_READ_SIZE_ERROR = 9,
	MONGO_COMMAND_FAILED = 10,
	MONGO_WRITE_ERROR = 11,
	MONGO_NS_INVALID = 12,
	MONGO_BSON_INVALID = 13,
	MONGO_BSON_NOT_FINISHED = 14,
	MONGO_BSON_TOO_LARGE = 15,
	MONGO_WRITE_CONCERN_INVALID = 16
};
enum PC_MONGO_CURSOR_ERROR_T {
	MONGO_CURSOR_EXHAUSTED = 0,
	MONGO_CURSOR_INVALID = 1,
	MONGO_CURSOR_PENDING = 2,
	MONGO_CURSOR_QUERY_FAIL = 3,
	MONGO_CURSOR_BSON_ERROR = 4
};

struct __anonstruct_bson_iterator_10;
struct __anonstruct_bson_11;
union __anonunion_bson_oid_t_12;
struct __anonstruct_bson_timestamp_t_13;
struct __anonstruct_mongo_header_14;
struct __anonstruct_mongo_reply_fields_16;
struct __anonstruct_mongo_reply_17;
struct mongo_host_port;
struct mongo_write_concern;
struct __anonstruct_mongo_replset_18;
struct mongo;
struct __anonstruct_mongo_cursor_19;
struct __anonstruct_gridfs_21;
struct __anonstruct_gridfile_22;
struct mongo_md5_state_s;
struct __anonstruct_mongo_message_15;

typedef struct __anonstruct_bson_iterator_10 bson_iterator;
typedef struct __anonstruct_bson_11 bson;
typedef union __anonunion_bson_oid_t_12 bson_oid_t;
typedef struct __anonstruct_bson_timestamp_t_13 bson_timestamp_t;
typedef struct __anonstruct_mongo_header_14 mongo_header;
typedef struct __anonstruct_mongo_reply_fields_16 mongo_reply_fields;
typedef struct __anonstruct_mongo_reply_17 mongo_reply;
typedef struct __anonstruct_mongo_replset_18 mongo_replset;
typedef struct __anonstruct_mongo_cursor_19 mongo_cursor;
typedef struct __anonstruct_gridfs_21 gridfs;
typedef struct __anonstruct_gridfile_22 gridfile;
typedef struct __anonstruct_mongo_message_15 mongo_message;

#pragma pack(1)
struct __anonstruct_mongo_header_14 {
	int len;
	int id;
	int responseTo;
	int op;
};
struct __anonstruct_mongo_message_15 {
	mongo_header head;
	char data;
};
struct __anonstruct_mongo_reply_fields_16 {
	int flag;
	long long cursorID;
	int start;
	int num;
};
struct __anonstruct_mongo_reply_17 {
	mongo_header head;
	mongo_reply_fields fields;
	char objs;
};
union __anonunion_bson_oid_t_12 {
	char bytes[12];
	int ints[3];
};
#pragma pack()

struct mongo_md5_state_s {
	unsigned int count[2];
	unsigned int abcd[4];
	unsigned char buf[64];
};
struct __anonstruct_bson_iterator_10 {
	char const * cur;
	int first;
};
struct __anonstruct_bson_11 {
	char * data;
	char * cur;
	int dataSize;
	int finished;
	int stack[32];
	int stackPos;
	int err;
	char * errstr;
};
struct mongo_host_port {
	char host[255];
	int port;
	struct mongo_host_port * next;
};
struct mongo_write_concern {
	int w;
	int wtimeout;
	int j;
	int fsync;
	char const * mode;
	bson * cmd;
};
struct __anonstruct_mongo_replset_18 {
	struct mongo_host_port * seeds;
	struct mongo_host_port * hosts;
	char * name;
	int primary_connected;
};
struct mongo {
	struct mongo_host_port * primary;
	mongo_replset * replset;
	int sock;
	int flags;
	int conn_timeout_ms;
	int op_timeout_ms;
	int max_bson_size;
	int connected;
	struct mongo_write_concern * write_concern;
	unsigned int err;
	int errcode;
	char errstr[128];
	int lasterrcode;
	char lasterrstr[128];
};
struct __anonstruct_mongo_cursor_19 {
	mongo_reply * reply;
	struct mongo * conn;
	char const * ns;
	int flags;
	int seen;
	bson current;
	unsigned int err;
	bson * query;
	bson * fields;
	int options;
	int limit;
	int skip;
};
struct __anonstruct_gridfs_21 {
	struct mongo * client;
	char const * dbname;
	char const * prefix;
	char const * files_ns;
	char const * chunks_ns;
};
struct __anonstruct_gridfile_22 {
	gridfs * gfs;
	bson * meta;
	unsigned long long pos;
	bson_oid_t id;
	char * remote_name;
	char * content_type;
	unsigned long long length;
	int chunk_num;
	char * pending_data;
	int pending_len;
};
struct __anonstruct_bson_timestamp_t_13 {
	int i;
	int t;
};

#endif
