class
	S_STDLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	strtol (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): INTEGER_32
		require
			not a_nptr.is_void
		do
			Result := c_strtol (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtol (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return strtol($a_nptr, $a_endptr, $a_base);"
		end

	atoi (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_nptr.is_void
			not a_nptr.is_void
		do
			Result := (strtol (a_nptr, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)).to_integer_32
		end

	rand: INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return rand();"
		end

	srand (a_seed: NATURAL_32)
		external
			"C inline use <libmongo.h>"
		alias
			"srand($a_seed);"
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a_ptr: CE_POINTER [ANY])
		do
			c_free (a_ptr.c_pointer)
		end

	c_free (a_ptr: POINTER)
		external
			"C inline use <libmongo.h>"
		alias
			"free($a_ptr);"
		end

	exit (a_status: INTEGER_32)
		external
			"C inline use <libmongo.h>"
		alias
			"exit($a_status);"
		ensure
			False
		end

feature {ANY} -- routine addresses

	malloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent malloc)
		end

	realloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent realloc)
		end

	free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent free)
		end

end
