class
	PD_BSON_ITERATOR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_cur: CE_POINTER [INTEGER_8]
				a_first: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.cur := a_data.a_cur
			Current.first := a_data.a_first
		end

feature {ANY} -- fields

	cur: CE_POINTER [INTEGER_8] assign set__cur
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__cur (internal_c_pointer))
		end

	first: INTEGER_32 assign set__first
		do
			Result := c__first (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__cur (a_cur: CE_POINTER [INTEGER_8])
		do
			c__set_cur (internal_c_pointer, a_cur.c_pointer)
		end

	set__first (a_first: INTEGER_32)
		do
			c__set_first (internal_c_pointer, a_first)
		end

feature {PD_BSON_ITERATOR} -- private attributes

	bson_numstrs: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			create Result.make (create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_cstring ("0%/0/"),
					ce_cstring ("1%/0/"),
					ce_cstring ("2%/0/"),
					ce_cstring ("3%/0/"),
					ce_cstring ("4%/0/"),
					ce_cstring ("5%/0/"),
					ce_cstring ("6%/0/"),
					ce_cstring ("7%/0/"),
					ce_cstring ("8%/0/"),
					ce_cstring ("9%/0/"),
					ce_cstring ("10%/0/"),
					ce_cstring ("11%/0/"),
					ce_cstring ("12%/0/"),
					ce_cstring ("13%/0/"),
					ce_cstring ("14%/0/"),
					ce_cstring ("15%/0/"),
					ce_cstring ("16%/0/"),
					ce_cstring ("17%/0/"),
					ce_cstring ("18%/0/"),
					ce_cstring ("19%/0/"),
					ce_cstring ("20%/0/"),
					ce_cstring ("21%/0/"),
					ce_cstring ("22%/0/"),
					ce_cstring ("23%/0/"),
					ce_cstring ("24%/0/"),
					ce_cstring ("25%/0/"),
					ce_cstring ("26%/0/"),
					ce_cstring ("27%/0/"),
					ce_cstring ("28%/0/"),
					ce_cstring ("29%/0/"),
					ce_cstring ("30%/0/"),
					ce_cstring ("31%/0/"),
					ce_cstring ("32%/0/"),
					ce_cstring ("33%/0/"),
					ce_cstring ("34%/0/"),
					ce_cstring ("35%/0/"),
					ce_cstring ("36%/0/"),
					ce_cstring ("37%/0/"),
					ce_cstring ("38%/0/"),
					ce_cstring ("39%/0/"),
					ce_cstring ("40%/0/"),
					ce_cstring ("41%/0/"),
					ce_cstring ("42%/0/"),
					ce_cstring ("43%/0/"),
					ce_cstring ("44%/0/"),
					ce_cstring ("45%/0/"),
					ce_cstring ("46%/0/"),
					ce_cstring ("47%/0/"),
					ce_cstring ("48%/0/"),
					ce_cstring ("49%/0/"),
					ce_cstring ("50%/0/"),
					ce_cstring ("51%/0/"),
					ce_cstring ("52%/0/"),
					ce_cstring ("53%/0/"),
					ce_cstring ("54%/0/"),
					ce_cstring ("55%/0/"),
					ce_cstring ("56%/0/"),
					ce_cstring ("57%/0/"),
					ce_cstring ("58%/0/"),
					ce_cstring ("59%/0/"),
					ce_cstring ("60%/0/"),
					ce_cstring ("61%/0/"),
					ce_cstring ("62%/0/"),
					ce_cstring ("63%/0/"),
					ce_cstring ("64%/0/"),
					ce_cstring ("65%/0/"),
					ce_cstring ("66%/0/"),
					ce_cstring ("67%/0/"),
					ce_cstring ("68%/0/"),
					ce_cstring ("69%/0/"),
					ce_cstring ("70%/0/"),
					ce_cstring ("71%/0/"),
					ce_cstring ("72%/0/"),
					ce_cstring ("73%/0/"),
					ce_cstring ("74%/0/"),
					ce_cstring ("75%/0/"),
					ce_cstring ("76%/0/"),
					ce_cstring ("77%/0/"),
					ce_cstring ("78%/0/"),
					ce_cstring ("79%/0/"),
					ce_cstring ("80%/0/"),
					ce_cstring ("81%/0/"),
					ce_cstring ("82%/0/"),
					ce_cstring ("83%/0/"),
					ce_cstring ("84%/0/"),
					ce_cstring ("85%/0/"),
					ce_cstring ("86%/0/"),
					ce_cstring ("87%/0/"),
					ce_cstring ("88%/0/"),
					ce_cstring ("89%/0/"),
					ce_cstring ("90%/0/"),
					ce_cstring ("91%/0/"),
					ce_cstring ("92%/0/"),
					ce_cstring ("93%/0/"),
					ce_cstring ("94%/0/"),
					ce_cstring ("95%/0/"),
					ce_cstring ("96%/0/"),
					ce_cstring ("97%/0/"),
					ce_cstring ("98%/0/"),
					ce_cstring ("99%/0/"),
					ce_cstring ("100%/0/"),
					ce_cstring ("101%/0/"),
					ce_cstring ("102%/0/"),
					ce_cstring ("103%/0/"),
					ce_cstring ("104%/0/"),
					ce_cstring ("105%/0/"),
					ce_cstring ("106%/0/"),
					ce_cstring ("107%/0/"),
					ce_cstring ("108%/0/"),
					ce_cstring ("109%/0/"),
					ce_cstring ("110%/0/"),
					ce_cstring ("111%/0/"),
					ce_cstring ("112%/0/"),
					ce_cstring ("113%/0/"),
					ce_cstring ("114%/0/"),
					ce_cstring ("115%/0/"),
					ce_cstring ("116%/0/"),
					ce_cstring ("117%/0/"),
					ce_cstring ("118%/0/"),
					ce_cstring ("119%/0/"),
					ce_cstring ("120%/0/"),
					ce_cstring ("121%/0/"),
					ce_cstring ("122%/0/"),
					ce_cstring ("123%/0/"),
					ce_cstring ("124%/0/"),
					ce_cstring ("125%/0/"),
					ce_cstring ("126%/0/"),
					ce_cstring ("127%/0/"),
					ce_cstring ("128%/0/"),
					ce_cstring ("129%/0/"),
					ce_cstring ("130%/0/"),
					ce_cstring ("131%/0/"),
					ce_cstring ("132%/0/"),
					ce_cstring ("133%/0/"),
					ce_cstring ("134%/0/"),
					ce_cstring ("135%/0/"),
					ce_cstring ("136%/0/"),
					ce_cstring ("137%/0/"),
					ce_cstring ("138%/0/"),
					ce_cstring ("139%/0/"),
					ce_cstring ("140%/0/"),
					ce_cstring ("141%/0/"),
					ce_cstring ("142%/0/"),
					ce_cstring ("143%/0/"),
					ce_cstring ("144%/0/"),
					ce_cstring ("145%/0/"),
					ce_cstring ("146%/0/"),
					ce_cstring ("147%/0/"),
					ce_cstring ("148%/0/"),
					ce_cstring ("149%/0/"),
					ce_cstring ("150%/0/"),
					ce_cstring ("151%/0/"),
					ce_cstring ("152%/0/"),
					ce_cstring ("153%/0/"),
					ce_cstring ("154%/0/"),
					ce_cstring ("155%/0/"),
					ce_cstring ("156%/0/"),
					ce_cstring ("157%/0/"),
					ce_cstring ("158%/0/"),
					ce_cstring ("159%/0/"),
					ce_cstring ("160%/0/"),
					ce_cstring ("161%/0/"),
					ce_cstring ("162%/0/"),
					ce_cstring ("163%/0/"),
					ce_cstring ("164%/0/"),
					ce_cstring ("165%/0/"),
					ce_cstring ("166%/0/"),
					ce_cstring ("167%/0/"),
					ce_cstring ("168%/0/"),
					ce_cstring ("169%/0/"),
					ce_cstring ("170%/0/"),
					ce_cstring ("171%/0/"),
					ce_cstring ("172%/0/"),
					ce_cstring ("173%/0/"),
					ce_cstring ("174%/0/"),
					ce_cstring ("175%/0/"),
					ce_cstring ("176%/0/"),
					ce_cstring ("177%/0/"),
					ce_cstring ("178%/0/"),
					ce_cstring ("179%/0/"),
					ce_cstring ("180%/0/"),
					ce_cstring ("181%/0/"),
					ce_cstring ("182%/0/"),
					ce_cstring ("183%/0/"),
					ce_cstring ("184%/0/"),
					ce_cstring ("185%/0/"),
					ce_cstring ("186%/0/"),
					ce_cstring ("187%/0/"),
					ce_cstring ("188%/0/"),
					ce_cstring ("189%/0/"),
					ce_cstring ("190%/0/"),
					ce_cstring ("191%/0/"),
					ce_cstring ("192%/0/"),
					ce_cstring ("193%/0/"),
					ce_cstring ("194%/0/"),
					ce_cstring ("195%/0/"),
					ce_cstring ("196%/0/"),
					ce_cstring ("197%/0/"),
					ce_cstring ("198%/0/"),
					ce_cstring ("199%/0/"),
					ce_cstring ("200%/0/"),
					ce_cstring ("201%/0/"),
					ce_cstring ("202%/0/"),
					ce_cstring ("203%/0/"),
					ce_cstring ("204%/0/"),
					ce_cstring ("205%/0/"),
					ce_cstring ("206%/0/"),
					ce_cstring ("207%/0/"),
					ce_cstring ("208%/0/"),
					ce_cstring ("209%/0/"),
					ce_cstring ("210%/0/"),
					ce_cstring ("211%/0/"),
					ce_cstring ("212%/0/"),
					ce_cstring ("213%/0/"),
					ce_cstring ("214%/0/"),
					ce_cstring ("215%/0/"),
					ce_cstring ("216%/0/"),
					ce_cstring ("217%/0/"),
					ce_cstring ("218%/0/"),
					ce_cstring ("219%/0/"),
					ce_cstring ("220%/0/"),
					ce_cstring ("221%/0/"),
					ce_cstring ("222%/0/"),
					ce_cstring ("223%/0/"),
					ce_cstring ("224%/0/"),
					ce_cstring ("225%/0/"),
					ce_cstring ("226%/0/"),
					ce_cstring ("227%/0/"),
					ce_cstring ("228%/0/"),
					ce_cstring ("229%/0/"),
					ce_cstring ("230%/0/"),
					ce_cstring ("231%/0/"),
					ce_cstring ("232%/0/"),
					ce_cstring ("233%/0/"),
					ce_cstring ("234%/0/"),
					ce_cstring ("235%/0/"),
					ce_cstring ("236%/0/"),
					ce_cstring ("237%/0/"),
					ce_cstring ("238%/0/"),
					ce_cstring ("239%/0/"),
					ce_cstring ("240%/0/"),
					ce_cstring ("241%/0/"),
					ce_cstring ("242%/0/"),
					ce_cstring ("243%/0/"),
					ce_cstring ("244%/0/"),
					ce_cstring ("245%/0/"),
					ce_cstring ("246%/0/"),
					ce_cstring ("247%/0/"),
					ce_cstring ("248%/0/"),
					ce_cstring ("249%/0/"),
					ce_cstring ("250%/0/"),
					ce_cstring ("251%/0/"),
					ce_cstring ("252%/0/"),
					ce_cstring ("253%/0/"),
					ce_cstring ("254%/0/"),
					ce_cstring ("255%/0/"),
					ce_cstring ("256%/0/"),
					ce_cstring ("257%/0/"),
					ce_cstring ("258%/0/"),
					ce_cstring ("259%/0/"),
					ce_cstring ("260%/0/"),
					ce_cstring ("261%/0/"),
					ce_cstring ("262%/0/"),
					ce_cstring ("263%/0/"),
					ce_cstring ("264%/0/"),
					ce_cstring ("265%/0/"),
					ce_cstring ("266%/0/"),
					ce_cstring ("267%/0/"),
					ce_cstring ("268%/0/"),
					ce_cstring ("269%/0/"),
					ce_cstring ("270%/0/"),
					ce_cstring ("271%/0/"),
					ce_cstring ("272%/0/"),
					ce_cstring ("273%/0/"),
					ce_cstring ("274%/0/"),
					ce_cstring ("275%/0/"),
					ce_cstring ("276%/0/"),
					ce_cstring ("277%/0/"),
					ce_cstring ("278%/0/"),
					ce_cstring ("279%/0/"),
					ce_cstring ("280%/0/"),
					ce_cstring ("281%/0/"),
					ce_cstring ("282%/0/"),
					ce_cstring ("283%/0/"),
					ce_cstring ("284%/0/"),
					ce_cstring ("285%/0/"),
					ce_cstring ("286%/0/"),
					ce_cstring ("287%/0/"),
					ce_cstring ("288%/0/"),
					ce_cstring ("289%/0/"),
					ce_cstring ("290%/0/"),
					ce_cstring ("291%/0/"),
					ce_cstring ("292%/0/"),
					ce_cstring ("293%/0/"),
					ce_cstring ("294%/0/"),
					ce_cstring ("295%/0/"),
					ce_cstring ("296%/0/"),
					ce_cstring ("297%/0/"),
					ce_cstring ("298%/0/"),
					ce_cstring ("299%/0/"),
					ce_cstring ("300%/0/"),
					ce_cstring ("301%/0/"),
					ce_cstring ("302%/0/"),
					ce_cstring ("303%/0/"),
					ce_cstring ("304%/0/"),
					ce_cstring ("305%/0/"),
					ce_cstring ("306%/0/"),
					ce_cstring ("307%/0/"),
					ce_cstring ("308%/0/"),
					ce_cstring ("309%/0/"),
					ce_cstring ("310%/0/"),
					ce_cstring ("311%/0/"),
					ce_cstring ("312%/0/"),
					ce_cstring ("313%/0/"),
					ce_cstring ("314%/0/"),
					ce_cstring ("315%/0/"),
					ce_cstring ("316%/0/"),
					ce_cstring ("317%/0/"),
					ce_cstring ("318%/0/"),
					ce_cstring ("319%/0/"),
					ce_cstring ("320%/0/"),
					ce_cstring ("321%/0/"),
					ce_cstring ("322%/0/"),
					ce_cstring ("323%/0/"),
					ce_cstring ("324%/0/"),
					ce_cstring ("325%/0/"),
					ce_cstring ("326%/0/"),
					ce_cstring ("327%/0/"),
					ce_cstring ("328%/0/"),
					ce_cstring ("329%/0/"),
					ce_cstring ("330%/0/"),
					ce_cstring ("331%/0/"),
					ce_cstring ("332%/0/"),
					ce_cstring ("333%/0/"),
					ce_cstring ("334%/0/"),
					ce_cstring ("335%/0/"),
					ce_cstring ("336%/0/"),
					ce_cstring ("337%/0/"),
					ce_cstring ("338%/0/"),
					ce_cstring ("339%/0/"),
					ce_cstring ("340%/0/"),
					ce_cstring ("341%/0/"),
					ce_cstring ("342%/0/"),
					ce_cstring ("343%/0/"),
					ce_cstring ("344%/0/"),
					ce_cstring ("345%/0/"),
					ce_cstring ("346%/0/"),
					ce_cstring ("347%/0/"),
					ce_cstring ("348%/0/"),
					ce_cstring ("349%/0/"),
					ce_cstring ("350%/0/"),
					ce_cstring ("351%/0/"),
					ce_cstring ("352%/0/"),
					ce_cstring ("353%/0/"),
					ce_cstring ("354%/0/"),
					ce_cstring ("355%/0/"),
					ce_cstring ("356%/0/"),
					ce_cstring ("357%/0/"),
					ce_cstring ("358%/0/"),
					ce_cstring ("359%/0/"),
					ce_cstring ("360%/0/"),
					ce_cstring ("361%/0/"),
					ce_cstring ("362%/0/"),
					ce_cstring ("363%/0/"),
					ce_cstring ("364%/0/"),
					ce_cstring ("365%/0/"),
					ce_cstring ("366%/0/"),
					ce_cstring ("367%/0/"),
					ce_cstring ("368%/0/"),
					ce_cstring ("369%/0/"),
					ce_cstring ("370%/0/"),
					ce_cstring ("371%/0/"),
					ce_cstring ("372%/0/"),
					ce_cstring ("373%/0/"),
					ce_cstring ("374%/0/"),
					ce_cstring ("375%/0/"),
					ce_cstring ("376%/0/"),
					ce_cstring ("377%/0/"),
					ce_cstring ("378%/0/"),
					ce_cstring ("379%/0/"),
					ce_cstring ("380%/0/"),
					ce_cstring ("381%/0/"),
					ce_cstring ("382%/0/"),
					ce_cstring ("383%/0/"),
					ce_cstring ("384%/0/"),
					ce_cstring ("385%/0/"),
					ce_cstring ("386%/0/"),
					ce_cstring ("387%/0/"),
					ce_cstring ("388%/0/"),
					ce_cstring ("389%/0/"),
					ce_cstring ("390%/0/"),
					ce_cstring ("391%/0/"),
					ce_cstring ("392%/0/"),
					ce_cstring ("393%/0/"),
					ce_cstring ("394%/0/"),
					ce_cstring ("395%/0/"),
					ce_cstring ("396%/0/"),
					ce_cstring ("397%/0/"),
					ce_cstring ("398%/0/"),
					ce_cstring ("399%/0/"),
					ce_cstring ("400%/0/"),
					ce_cstring ("401%/0/"),
					ce_cstring ("402%/0/"),
					ce_cstring ("403%/0/"),
					ce_cstring ("404%/0/"),
					ce_cstring ("405%/0/"),
					ce_cstring ("406%/0/"),
					ce_cstring ("407%/0/"),
					ce_cstring ("408%/0/"),
					ce_cstring ("409%/0/"),
					ce_cstring ("410%/0/"),
					ce_cstring ("411%/0/"),
					ce_cstring ("412%/0/"),
					ce_cstring ("413%/0/"),
					ce_cstring ("414%/0/"),
					ce_cstring ("415%/0/"),
					ce_cstring ("416%/0/"),
					ce_cstring ("417%/0/"),
					ce_cstring ("418%/0/"),
					ce_cstring ("419%/0/"),
					ce_cstring ("420%/0/"),
					ce_cstring ("421%/0/"),
					ce_cstring ("422%/0/"),
					ce_cstring ("423%/0/"),
					ce_cstring ("424%/0/"),
					ce_cstring ("425%/0/"),
					ce_cstring ("426%/0/"),
					ce_cstring ("427%/0/"),
					ce_cstring ("428%/0/"),
					ce_cstring ("429%/0/"),
					ce_cstring ("430%/0/"),
					ce_cstring ("431%/0/"),
					ce_cstring ("432%/0/"),
					ce_cstring ("433%/0/"),
					ce_cstring ("434%/0/"),
					ce_cstring ("435%/0/"),
					ce_cstring ("436%/0/"),
					ce_cstring ("437%/0/"),
					ce_cstring ("438%/0/"),
					ce_cstring ("439%/0/"),
					ce_cstring ("440%/0/"),
					ce_cstring ("441%/0/"),
					ce_cstring ("442%/0/"),
					ce_cstring ("443%/0/"),
					ce_cstring ("444%/0/"),
					ce_cstring ("445%/0/"),
					ce_cstring ("446%/0/"),
					ce_cstring ("447%/0/"),
					ce_cstring ("448%/0/"),
					ce_cstring ("449%/0/"),
					ce_cstring ("450%/0/"),
					ce_cstring ("451%/0/"),
					ce_cstring ("452%/0/"),
					ce_cstring ("453%/0/"),
					ce_cstring ("454%/0/"),
					ce_cstring ("455%/0/"),
					ce_cstring ("456%/0/"),
					ce_cstring ("457%/0/"),
					ce_cstring ("458%/0/"),
					ce_cstring ("459%/0/"),
					ce_cstring ("460%/0/"),
					ce_cstring ("461%/0/"),
					ce_cstring ("462%/0/"),
					ce_cstring ("463%/0/"),
					ce_cstring ("464%/0/"),
					ce_cstring ("465%/0/"),
					ce_cstring ("466%/0/"),
					ce_cstring ("467%/0/"),
					ce_cstring ("468%/0/"),
					ce_cstring ("469%/0/"),
					ce_cstring ("470%/0/"),
					ce_cstring ("471%/0/"),
					ce_cstring ("472%/0/"),
					ce_cstring ("473%/0/"),
					ce_cstring ("474%/0/"),
					ce_cstring ("475%/0/"),
					ce_cstring ("476%/0/"),
					ce_cstring ("477%/0/"),
					ce_cstring ("478%/0/"),
					ce_cstring ("479%/0/"),
					ce_cstring ("480%/0/"),
					ce_cstring ("481%/0/"),
					ce_cstring ("482%/0/"),
					ce_cstring ("483%/0/"),
					ce_cstring ("484%/0/"),
					ce_cstring ("485%/0/"),
					ce_cstring ("486%/0/"),
					ce_cstring ("487%/0/"),
					ce_cstring ("488%/0/"),
					ce_cstring ("489%/0/"),
					ce_cstring ("490%/0/"),
					ce_cstring ("491%/0/"),
					ce_cstring ("492%/0/"),
					ce_cstring ("493%/0/"),
					ce_cstring ("494%/0/"),
					ce_cstring ("495%/0/"),
					ce_cstring ("496%/0/"),
					ce_cstring ("497%/0/"),
					ce_cstring ("498%/0/"),
					ce_cstring ("499%/0/"),
					ce_cstring ("500%/0/"),
					ce_cstring ("501%/0/"),
					ce_cstring ("502%/0/"),
					ce_cstring ("503%/0/"),
					ce_cstring ("504%/0/"),
					ce_cstring ("505%/0/"),
					ce_cstring ("506%/0/"),
					ce_cstring ("507%/0/"),
					ce_cstring ("508%/0/"),
					ce_cstring ("509%/0/"),
					ce_cstring ("510%/0/"),
					ce_cstring ("511%/0/"),
					ce_cstring ("512%/0/"),
					ce_cstring ("513%/0/"),
					ce_cstring ("514%/0/"),
					ce_cstring ("515%/0/"),
					ce_cstring ("516%/0/"),
					ce_cstring ("517%/0/"),
					ce_cstring ("518%/0/"),
					ce_cstring ("519%/0/"),
					ce_cstring ("520%/0/"),
					ce_cstring ("521%/0/"),
					ce_cstring ("522%/0/"),
					ce_cstring ("523%/0/"),
					ce_cstring ("524%/0/"),
					ce_cstring ("525%/0/"),
					ce_cstring ("526%/0/"),
					ce_cstring ("527%/0/"),
					ce_cstring ("528%/0/"),
					ce_cstring ("529%/0/"),
					ce_cstring ("530%/0/"),
					ce_cstring ("531%/0/"),
					ce_cstring ("532%/0/"),
					ce_cstring ("533%/0/"),
					ce_cstring ("534%/0/"),
					ce_cstring ("535%/0/"),
					ce_cstring ("536%/0/"),
					ce_cstring ("537%/0/"),
					ce_cstring ("538%/0/"),
					ce_cstring ("539%/0/"),
					ce_cstring ("540%/0/"),
					ce_cstring ("541%/0/"),
					ce_cstring ("542%/0/"),
					ce_cstring ("543%/0/"),
					ce_cstring ("544%/0/"),
					ce_cstring ("545%/0/"),
					ce_cstring ("546%/0/"),
					ce_cstring ("547%/0/"),
					ce_cstring ("548%/0/"),
					ce_cstring ("549%/0/"),
					ce_cstring ("550%/0/"),
					ce_cstring ("551%/0/"),
					ce_cstring ("552%/0/"),
					ce_cstring ("553%/0/"),
					ce_cstring ("554%/0/"),
					ce_cstring ("555%/0/"),
					ce_cstring ("556%/0/"),
					ce_cstring ("557%/0/"),
					ce_cstring ("558%/0/"),
					ce_cstring ("559%/0/"),
					ce_cstring ("560%/0/"),
					ce_cstring ("561%/0/"),
					ce_cstring ("562%/0/"),
					ce_cstring ("563%/0/"),
					ce_cstring ("564%/0/"),
					ce_cstring ("565%/0/"),
					ce_cstring ("566%/0/"),
					ce_cstring ("567%/0/"),
					ce_cstring ("568%/0/"),
					ce_cstring ("569%/0/"),
					ce_cstring ("570%/0/"),
					ce_cstring ("571%/0/"),
					ce_cstring ("572%/0/"),
					ce_cstring ("573%/0/"),
					ce_cstring ("574%/0/"),
					ce_cstring ("575%/0/"),
					ce_cstring ("576%/0/"),
					ce_cstring ("577%/0/"),
					ce_cstring ("578%/0/"),
					ce_cstring ("579%/0/"),
					ce_cstring ("580%/0/"),
					ce_cstring ("581%/0/"),
					ce_cstring ("582%/0/"),
					ce_cstring ("583%/0/"),
					ce_cstring ("584%/0/"),
					ce_cstring ("585%/0/"),
					ce_cstring ("586%/0/"),
					ce_cstring ("587%/0/"),
					ce_cstring ("588%/0/"),
					ce_cstring ("589%/0/"),
					ce_cstring ("590%/0/"),
					ce_cstring ("591%/0/"),
					ce_cstring ("592%/0/"),
					ce_cstring ("593%/0/"),
					ce_cstring ("594%/0/"),
					ce_cstring ("595%/0/"),
					ce_cstring ("596%/0/"),
					ce_cstring ("597%/0/"),
					ce_cstring ("598%/0/"),
					ce_cstring ("599%/0/"),
					ce_cstring ("600%/0/"),
					ce_cstring ("601%/0/"),
					ce_cstring ("602%/0/"),
					ce_cstring ("603%/0/"),
					ce_cstring ("604%/0/"),
					ce_cstring ("605%/0/"),
					ce_cstring ("606%/0/"),
					ce_cstring ("607%/0/"),
					ce_cstring ("608%/0/"),
					ce_cstring ("609%/0/"),
					ce_cstring ("610%/0/"),
					ce_cstring ("611%/0/"),
					ce_cstring ("612%/0/"),
					ce_cstring ("613%/0/"),
					ce_cstring ("614%/0/"),
					ce_cstring ("615%/0/"),
					ce_cstring ("616%/0/"),
					ce_cstring ("617%/0/"),
					ce_cstring ("618%/0/"),
					ce_cstring ("619%/0/"),
					ce_cstring ("620%/0/"),
					ce_cstring ("621%/0/"),
					ce_cstring ("622%/0/"),
					ce_cstring ("623%/0/"),
					ce_cstring ("624%/0/"),
					ce_cstring ("625%/0/"),
					ce_cstring ("626%/0/"),
					ce_cstring ("627%/0/"),
					ce_cstring ("628%/0/"),
					ce_cstring ("629%/0/"),
					ce_cstring ("630%/0/"),
					ce_cstring ("631%/0/"),
					ce_cstring ("632%/0/"),
					ce_cstring ("633%/0/"),
					ce_cstring ("634%/0/"),
					ce_cstring ("635%/0/"),
					ce_cstring ("636%/0/"),
					ce_cstring ("637%/0/"),
					ce_cstring ("638%/0/"),
					ce_cstring ("639%/0/"),
					ce_cstring ("640%/0/"),
					ce_cstring ("641%/0/"),
					ce_cstring ("642%/0/"),
					ce_cstring ("643%/0/"),
					ce_cstring ("644%/0/"),
					ce_cstring ("645%/0/"),
					ce_cstring ("646%/0/"),
					ce_cstring ("647%/0/"),
					ce_cstring ("648%/0/"),
					ce_cstring ("649%/0/"),
					ce_cstring ("650%/0/"),
					ce_cstring ("651%/0/"),
					ce_cstring ("652%/0/"),
					ce_cstring ("653%/0/"),
					ce_cstring ("654%/0/"),
					ce_cstring ("655%/0/"),
					ce_cstring ("656%/0/"),
					ce_cstring ("657%/0/"),
					ce_cstring ("658%/0/"),
					ce_cstring ("659%/0/"),
					ce_cstring ("660%/0/"),
					ce_cstring ("661%/0/"),
					ce_cstring ("662%/0/"),
					ce_cstring ("663%/0/"),
					ce_cstring ("664%/0/"),
					ce_cstring ("665%/0/"),
					ce_cstring ("666%/0/"),
					ce_cstring ("667%/0/"),
					ce_cstring ("668%/0/"),
					ce_cstring ("669%/0/"),
					ce_cstring ("670%/0/"),
					ce_cstring ("671%/0/"),
					ce_cstring ("672%/0/"),
					ce_cstring ("673%/0/"),
					ce_cstring ("674%/0/"),
					ce_cstring ("675%/0/"),
					ce_cstring ("676%/0/"),
					ce_cstring ("677%/0/"),
					ce_cstring ("678%/0/"),
					ce_cstring ("679%/0/"),
					ce_cstring ("680%/0/"),
					ce_cstring ("681%/0/"),
					ce_cstring ("682%/0/"),
					ce_cstring ("683%/0/"),
					ce_cstring ("684%/0/"),
					ce_cstring ("685%/0/"),
					ce_cstring ("686%/0/"),
					ce_cstring ("687%/0/"),
					ce_cstring ("688%/0/"),
					ce_cstring ("689%/0/"),
					ce_cstring ("690%/0/"),
					ce_cstring ("691%/0/"),
					ce_cstring ("692%/0/"),
					ce_cstring ("693%/0/"),
					ce_cstring ("694%/0/"),
					ce_cstring ("695%/0/"),
					ce_cstring ("696%/0/"),
					ce_cstring ("697%/0/"),
					ce_cstring ("698%/0/"),
					ce_cstring ("699%/0/"),
					ce_cstring ("700%/0/"),
					ce_cstring ("701%/0/"),
					ce_cstring ("702%/0/"),
					ce_cstring ("703%/0/"),
					ce_cstring ("704%/0/"),
					ce_cstring ("705%/0/"),
					ce_cstring ("706%/0/"),
					ce_cstring ("707%/0/"),
					ce_cstring ("708%/0/"),
					ce_cstring ("709%/0/"),
					ce_cstring ("710%/0/"),
					ce_cstring ("711%/0/"),
					ce_cstring ("712%/0/"),
					ce_cstring ("713%/0/"),
					ce_cstring ("714%/0/"),
					ce_cstring ("715%/0/"),
					ce_cstring ("716%/0/"),
					ce_cstring ("717%/0/"),
					ce_cstring ("718%/0/"),
					ce_cstring ("719%/0/"),
					ce_cstring ("720%/0/"),
					ce_cstring ("721%/0/"),
					ce_cstring ("722%/0/"),
					ce_cstring ("723%/0/"),
					ce_cstring ("724%/0/"),
					ce_cstring ("725%/0/"),
					ce_cstring ("726%/0/"),
					ce_cstring ("727%/0/"),
					ce_cstring ("728%/0/"),
					ce_cstring ("729%/0/"),
					ce_cstring ("730%/0/"),
					ce_cstring ("731%/0/"),
					ce_cstring ("732%/0/"),
					ce_cstring ("733%/0/"),
					ce_cstring ("734%/0/"),
					ce_cstring ("735%/0/"),
					ce_cstring ("736%/0/"),
					ce_cstring ("737%/0/"),
					ce_cstring ("738%/0/"),
					ce_cstring ("739%/0/"),
					ce_cstring ("740%/0/"),
					ce_cstring ("741%/0/"),
					ce_cstring ("742%/0/"),
					ce_cstring ("743%/0/"),
					ce_cstring ("744%/0/"),
					ce_cstring ("745%/0/"),
					ce_cstring ("746%/0/"),
					ce_cstring ("747%/0/"),
					ce_cstring ("748%/0/"),
					ce_cstring ("749%/0/"),
					ce_cstring ("750%/0/"),
					ce_cstring ("751%/0/"),
					ce_cstring ("752%/0/"),
					ce_cstring ("753%/0/"),
					ce_cstring ("754%/0/"),
					ce_cstring ("755%/0/"),
					ce_cstring ("756%/0/"),
					ce_cstring ("757%/0/"),
					ce_cstring ("758%/0/"),
					ce_cstring ("759%/0/"),
					ce_cstring ("760%/0/"),
					ce_cstring ("761%/0/"),
					ce_cstring ("762%/0/"),
					ce_cstring ("763%/0/"),
					ce_cstring ("764%/0/"),
					ce_cstring ("765%/0/"),
					ce_cstring ("766%/0/"),
					ce_cstring ("767%/0/"),
					ce_cstring ("768%/0/"),
					ce_cstring ("769%/0/"),
					ce_cstring ("770%/0/"),
					ce_cstring ("771%/0/"),
					ce_cstring ("772%/0/"),
					ce_cstring ("773%/0/"),
					ce_cstring ("774%/0/"),
					ce_cstring ("775%/0/"),
					ce_cstring ("776%/0/"),
					ce_cstring ("777%/0/"),
					ce_cstring ("778%/0/"),
					ce_cstring ("779%/0/"),
					ce_cstring ("780%/0/"),
					ce_cstring ("781%/0/"),
					ce_cstring ("782%/0/"),
					ce_cstring ("783%/0/"),
					ce_cstring ("784%/0/"),
					ce_cstring ("785%/0/"),
					ce_cstring ("786%/0/"),
					ce_cstring ("787%/0/"),
					ce_cstring ("788%/0/"),
					ce_cstring ("789%/0/"),
					ce_cstring ("790%/0/"),
					ce_cstring ("791%/0/"),
					ce_cstring ("792%/0/"),
					ce_cstring ("793%/0/"),
					ce_cstring ("794%/0/"),
					ce_cstring ("795%/0/"),
					ce_cstring ("796%/0/"),
					ce_cstring ("797%/0/"),
					ce_cstring ("798%/0/"),
					ce_cstring ("799%/0/"),
					ce_cstring ("800%/0/"),
					ce_cstring ("801%/0/"),
					ce_cstring ("802%/0/"),
					ce_cstring ("803%/0/"),
					ce_cstring ("804%/0/"),
					ce_cstring ("805%/0/"),
					ce_cstring ("806%/0/"),
					ce_cstring ("807%/0/"),
					ce_cstring ("808%/0/"),
					ce_cstring ("809%/0/"),
					ce_cstring ("810%/0/"),
					ce_cstring ("811%/0/"),
					ce_cstring ("812%/0/"),
					ce_cstring ("813%/0/"),
					ce_cstring ("814%/0/"),
					ce_cstring ("815%/0/"),
					ce_cstring ("816%/0/"),
					ce_cstring ("817%/0/"),
					ce_cstring ("818%/0/"),
					ce_cstring ("819%/0/"),
					ce_cstring ("820%/0/"),
					ce_cstring ("821%/0/"),
					ce_cstring ("822%/0/"),
					ce_cstring ("823%/0/"),
					ce_cstring ("824%/0/"),
					ce_cstring ("825%/0/"),
					ce_cstring ("826%/0/"),
					ce_cstring ("827%/0/"),
					ce_cstring ("828%/0/"),
					ce_cstring ("829%/0/"),
					ce_cstring ("830%/0/"),
					ce_cstring ("831%/0/"),
					ce_cstring ("832%/0/"),
					ce_cstring ("833%/0/"),
					ce_cstring ("834%/0/"),
					ce_cstring ("835%/0/"),
					ce_cstring ("836%/0/"),
					ce_cstring ("837%/0/"),
					ce_cstring ("838%/0/"),
					ce_cstring ("839%/0/"),
					ce_cstring ("840%/0/"),
					ce_cstring ("841%/0/"),
					ce_cstring ("842%/0/"),
					ce_cstring ("843%/0/"),
					ce_cstring ("844%/0/"),
					ce_cstring ("845%/0/"),
					ce_cstring ("846%/0/"),
					ce_cstring ("847%/0/"),
					ce_cstring ("848%/0/"),
					ce_cstring ("849%/0/"),
					ce_cstring ("850%/0/"),
					ce_cstring ("851%/0/"),
					ce_cstring ("852%/0/"),
					ce_cstring ("853%/0/"),
					ce_cstring ("854%/0/"),
					ce_cstring ("855%/0/"),
					ce_cstring ("856%/0/"),
					ce_cstring ("857%/0/"),
					ce_cstring ("858%/0/"),
					ce_cstring ("859%/0/"),
					ce_cstring ("860%/0/"),
					ce_cstring ("861%/0/"),
					ce_cstring ("862%/0/"),
					ce_cstring ("863%/0/"),
					ce_cstring ("864%/0/"),
					ce_cstring ("865%/0/"),
					ce_cstring ("866%/0/"),
					ce_cstring ("867%/0/"),
					ce_cstring ("868%/0/"),
					ce_cstring ("869%/0/"),
					ce_cstring ("870%/0/"),
					ce_cstring ("871%/0/"),
					ce_cstring ("872%/0/"),
					ce_cstring ("873%/0/"),
					ce_cstring ("874%/0/"),
					ce_cstring ("875%/0/"),
					ce_cstring ("876%/0/"),
					ce_cstring ("877%/0/"),
					ce_cstring ("878%/0/"),
					ce_cstring ("879%/0/"),
					ce_cstring ("880%/0/"),
					ce_cstring ("881%/0/"),
					ce_cstring ("882%/0/"),
					ce_cstring ("883%/0/"),
					ce_cstring ("884%/0/"),
					ce_cstring ("885%/0/"),
					ce_cstring ("886%/0/"),
					ce_cstring ("887%/0/"),
					ce_cstring ("888%/0/"),
					ce_cstring ("889%/0/"),
					ce_cstring ("890%/0/"),
					ce_cstring ("891%/0/"),
					ce_cstring ("892%/0/"),
					ce_cstring ("893%/0/"),
					ce_cstring ("894%/0/"),
					ce_cstring ("895%/0/"),
					ce_cstring ("896%/0/"),
					ce_cstring ("897%/0/"),
					ce_cstring ("898%/0/"),
					ce_cstring ("899%/0/"),
					ce_cstring ("900%/0/"),
					ce_cstring ("901%/0/"),
					ce_cstring ("902%/0/"),
					ce_cstring ("903%/0/"),
					ce_cstring ("904%/0/"),
					ce_cstring ("905%/0/"),
					ce_cstring ("906%/0/"),
					ce_cstring ("907%/0/"),
					ce_cstring ("908%/0/"),
					ce_cstring ("909%/0/"),
					ce_cstring ("910%/0/"),
					ce_cstring ("911%/0/"),
					ce_cstring ("912%/0/"),
					ce_cstring ("913%/0/"),
					ce_cstring ("914%/0/"),
					ce_cstring ("915%/0/"),
					ce_cstring ("916%/0/"),
					ce_cstring ("917%/0/"),
					ce_cstring ("918%/0/"),
					ce_cstring ("919%/0/"),
					ce_cstring ("920%/0/"),
					ce_cstring ("921%/0/"),
					ce_cstring ("922%/0/"),
					ce_cstring ("923%/0/"),
					ce_cstring ("924%/0/"),
					ce_cstring ("925%/0/"),
					ce_cstring ("926%/0/"),
					ce_cstring ("927%/0/"),
					ce_cstring ("928%/0/"),
					ce_cstring ("929%/0/"),
					ce_cstring ("930%/0/"),
					ce_cstring ("931%/0/"),
					ce_cstring ("932%/0/"),
					ce_cstring ("933%/0/"),
					ce_cstring ("934%/0/"),
					ce_cstring ("935%/0/"),
					ce_cstring ("936%/0/"),
					ce_cstring ("937%/0/"),
					ce_cstring ("938%/0/"),
					ce_cstring ("939%/0/"),
					ce_cstring ("940%/0/"),
					ce_cstring ("941%/0/"),
					ce_cstring ("942%/0/"),
					ce_cstring ("943%/0/"),
					ce_cstring ("944%/0/"),
					ce_cstring ("945%/0/"),
					ce_cstring ("946%/0/"),
					ce_cstring ("947%/0/"),
					ce_cstring ("948%/0/"),
					ce_cstring ("949%/0/"),
					ce_cstring ("950%/0/"),
					ce_cstring ("951%/0/"),
					ce_cstring ("952%/0/"),
					ce_cstring ("953%/0/"),
					ce_cstring ("954%/0/"),
					ce_cstring ("955%/0/"),
					ce_cstring ("956%/0/"),
					ce_cstring ("957%/0/"),
					ce_cstring ("958%/0/"),
					ce_cstring ("959%/0/"),
					ce_cstring ("960%/0/"),
					ce_cstring ("961%/0/"),
					ce_cstring ("962%/0/"),
					ce_cstring ("963%/0/"),
					ce_cstring ("964%/0/"),
					ce_cstring ("965%/0/"),
					ce_cstring ("966%/0/"),
					ce_cstring ("967%/0/"),
					ce_cstring ("968%/0/"),
					ce_cstring ("969%/0/"),
					ce_cstring ("970%/0/"),
					ce_cstring ("971%/0/"),
					ce_cstring ("972%/0/"),
					ce_cstring ("973%/0/"),
					ce_cstring ("974%/0/"),
					ce_cstring ("975%/0/"),
					ce_cstring ("976%/0/"),
					ce_cstring ("977%/0/"),
					ce_cstring ("978%/0/"),
					ce_cstring ("979%/0/"),
					ce_cstring ("980%/0/"),
					ce_cstring ("981%/0/"),
					ce_cstring ("982%/0/"),
					ce_cstring ("983%/0/"),
					ce_cstring ("984%/0/"),
					ce_cstring ("985%/0/"),
					ce_cstring ("986%/0/"),
					ce_cstring ("987%/0/"),
					ce_cstring ("988%/0/"),
					ce_cstring ("989%/0/"),
					ce_cstring ("990%/0/"),
					ce_cstring ("991%/0/"),
					ce_cstring ("992%/0/"),
					ce_cstring ("993%/0/"),
					ce_cstring ("994%/0/"),
					ce_cstring ("995%/0/"),
					ce_cstring ("996%/0/"),
					ce_cstring ("997%/0/"),
					ce_cstring ("998%/0/"),
					ce_cstring ("999%/0/")
				>>))
		end

feature {ANY} -- public routines

	init (a_b: CE_POINTER [PD_BSON])
		require
			not a_b.is_void
		do
			Current.cur := (a_b.item.data + 4)
			Current.first := 1
		end

	from_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			Current.cur := a_buffer + 4
			Current.first := 1
		end

	bson_find (a_obj: CE_POINTER [PD_BSON]; a_name: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a_obj.is_void
		local
			l_break: BOOLEAN
		do
			init (a_obj)
			from
			until
				l_break
			loop
				l_break := False
				if not next.to_boolean then
					l_break := True
				end
				if not l_break then
					if strcmp (a_name, (key)) = 0 then
						l_break := True
					end
				end
			end
			l_break := False
			Result := type
		end

	more: INTEGER_32
		do
			Result := cur.item.to_integer_32
		end

	next: NATURAL_32
		local
			l_ds: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_msg: CE_ARRAY [INTEGER_8]
			l_pos: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_msg.make (<<27>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if first.to_boolean then
						Current.first := 0
						Result := (cur.item).to_natural_32
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						inspect (type) -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 10 then l_pos := -1 + 3
						when 6 then l_pos := -1 + 3
						when 8 then l_pos := -1 + 4
						when 16 then l_pos := -1 + 5
						when 9 then l_pos := -1 + 6
						when 17 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 6
						when 18 then l_pos := -1 + 6
						when 7 then l_pos := -1 + 7
						when 13 then l_pos := -1 + 8
						when 14 then l_pos := -1 + 8
						when 2 then l_pos := -1 + 8
						when 5 then l_pos := -1 + 9
						when 15 then l_pos := -1 + 10
						when 4 then l_pos := -1 + 10
						when 3 then l_pos := -1 + 10
						when 12 then l_pos := -1 + 11
						when 11 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 2 then -- switch 1, case 0u
						Result := ({PC_BSON_TYPE}.Bson_eoo)
						l_return := True
				when 3 then -- switch 1, case 10u | switch 1, case 6u
						if not l_return then
							l_ds := 0
						end
						l_pos := -1 + 14 -- switch 1; break
				when 4 then -- switch 1, case 8u
						l_ds := 1
						l_pos := -1 + 14 -- switch 1; break
				when 5 then -- switch 1, case 16u
						l_ds := 4
						l_pos := -1 + 14 -- switch 1; break
				when 6 then -- switch 1, case 9u | switch 1, case 17u | switch 1, case 1u | switch 1, case 18u
						l_ds := 8
						l_pos := -1 + 14 -- switch 1; break
				when 7 then -- switch 1, case 7u
						l_ds := 12
						l_pos := -1 + 14 -- switch 1; break
				when 8 then -- switch 1, case 13u | switch 1, case 14u | switch 1, case 2u
						l_ds := 4 + (int_raw)
						l_pos := -1 + 14 -- switch 1; break
				when 9 then -- switch 1, case 5u
						l_ds := 5 + (int_raw)
						l_pos := -1 + 14 -- switch 1; break
				when 10 then -- switch 1, case 15u | switch 1, case 4u | switch 1, case 3u
						l_ds := int_raw
						l_pos := -1 + 14 -- switch 1; break
				when 11 then -- switch 1, case 12u
						l_ds := 16 + (int_raw)
						l_pos := -1 + 14 -- switch 1; break
				when 12 then -- switch 1, case 11u
						l_s := (value)
						l_p := l_s
						l_p := l_p + ((strlen (l_p)) + {NATURAL_32} 1).to_integer_32
						l_p := l_p + ((strlen (l_p)) + {NATURAL_32} 1).to_integer_32
						l_ds := l_p.distance (l_s)
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, default:
						l_msg[0] := (('u').code).to_integer_8
						l_msg[1] := (('n').code).to_integer_8
						l_msg[2] := (('k').code).to_integer_8
						l_msg[3] := (('n').code).to_integer_8
						l_msg[4] := (('o').code).to_integer_8
						l_msg[5] := (('w').code).to_integer_8
						l_msg[6] := (('n').code).to_integer_8
						l_msg[7] := ((' ').code).to_integer_8
						l_msg[8] := (('t').code).to_integer_8
						l_msg[9] := (('y').code).to_integer_8
						l_msg[10] := (('p').code).to_integer_8
						l_msg[11] := (('e').code).to_integer_8
						l_msg[12] := ((':').code).to_integer_8
						l_msg[13] := ((' ').code).to_integer_8
						l_msg[14] := (('0').code).to_integer_8
						l_msg[15] := (('0').code).to_integer_8
						l_msg[16] := (('0').code).to_integer_8
						l_msg[17] := (('0').code).to_integer_8
						l_msg[18] := (('0').code).to_integer_8
						l_msg[19] := (('0').code).to_integer_8
						l_msg[20] := (('0').code).to_integer_8
						l_msg[21] := (('0').code).to_integer_8
						l_msg[22] := (('0').code).to_integer_8
						l_msg[23] := (('0').code).to_integer_8
						l_msg[24] := (('0').code).to_integer_8
						l_msg[25] := (('0').code).to_integer_8
						l_msg[26] := (('%/0/').code).to_integer_8
						bson_numstr (l_msg + 14, ((cur[0]).to_natural_32).to_integer_32);
						(create {P_SRC_BSON_STATIC}).bson_fatal_msg (0, l_msg)
						Result := ({PC_BSON_TYPE}.Bson_eoo)
						l_return := True
				when 14 then -- switch 1, done: | if done
					if not l_return then
						Current.cur := cur + ((({NATURAL_32} 1 + (strlen (cur + 1))) + {NATURAL_32} 1) + l_ds.to_natural_32).to_integer_32
						Result := (cur.item).to_natural_32
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	type: NATURAL_32
		do
			Result := (cur[0]).to_natural_32
		end

	key: CE_POINTER [INTEGER_8]
		do
			Result := (cur + 1)
		end

	value: CE_POINTER [INTEGER_8]
		local
			l_t: CE_POINTER [INTEGER_8]
		do
			l_t := (cur + 1)
			l_t := l_t + ((strlen (l_t)) + {NATURAL_32} 1).to_integer_32
			Result := l_t
		end

	int_raw: INTEGER_32
		local
			l_out: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_out.make (<<1>>)

			memcpy (create {CE_VOID_POINTER}.make_cast (l_out), create {CE_VOID_POINTER}.make_cast ((value)), (4).to_natural_32).do_nothing
			Result := (l_out.item)
		end

	double_raw: REAL_64
		local
			l_out: CE_ARRAY [REAL_64]
		do
			create {CE_REAL_64_ARRAY} l_out.make (<<1>>)

			memcpy (create {CE_VOID_POINTER}.make_cast (l_out), create {CE_VOID_POINTER}.make_cast ((value)), (8).to_natural_32).do_nothing
			Result := (l_out.item)
		end

	long_raw: INTEGER_64
		local
			l_out: CE_ARRAY [INTEGER_64]
		do
			create {CE_INTEGER_64_ARRAY} l_out.make (<<1>>)

			memcpy (create {CE_VOID_POINTER}.make_cast (l_out), create {CE_VOID_POINTER}.make_cast ((value)), (8).to_natural_32).do_nothing
			Result := (l_out.item)
		end

	bool_raw: INTEGER_32
		do
			Result := ((value)[0]).to_integer_32
		end

	oid: CE_POINTER [PD_BSON_OID_T]
		do
			Result := (create {CE_CLASS_POINTER [PD_BSON_OID_T]}.make_cast ((value)))
		end

	int: INTEGER_32
		local
			l_pos: INTEGER_32
			l_return: BOOLEAN
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (type) -- switch 1 head
					when 16 then l_pos := -1 + 1
					when 18 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 16u
					Result := (int_raw)
					l_return := True
				when 2 then -- switch 1, case 18u
					if not l_return then
						Result := (long_raw).to_integer_32
						l_return := True
					end
				when 3 then -- switch 1, case 1u
					if not l_return then
						Result := (double_raw).truncated_to_integer
						l_return := True
					end
				when 4 then -- switch 1, default:
					if not l_return then
						Result := 0
					end
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	double: REAL_64
		local
			l_pos: INTEGER_32
			l_return: BOOLEAN
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (type) -- switch 1 head
					when 16 then l_pos := -1 + 1
					when 18 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 16u
					Result := (int_raw).to_double
					l_return := True
				when 2 then -- switch 1, case 18u
					if not l_return then
						Result := (long_raw).to_double
						l_return := True
					end
				when 3 then -- switch 1, case 1u
					if not l_return then
						Result := (double_raw)
						l_return := True
					end
				when 4 then -- switch 1, default:
					if not l_return then
						Result := (0).to_double
					end
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	long: INTEGER_64
		local
			l_pos: INTEGER_32
			l_return: BOOLEAN
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (type) -- switch 1 head
					when 16 then l_pos := -1 + 1
					when 18 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 16u
					Result := (int_raw).to_integer_64
					l_return := True
				when 2 then -- switch 1, case 18u
					if not l_return then
						Result := (long_raw)
						l_return := True
					end
				when 3 then -- switch 1, case 1u
					if not l_return then
						Result := (double_raw).truncated_to_integer_64
						l_return := True
					end
				when 4 then -- switch 1, default:
					if not l_return then
						Result := (0).to_integer_64
					end
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	timestamp_time: INTEGER_32
		local
			l_time_0: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_time_0.make (<<1>>)

			memcpy (create {CE_VOID_POINTER}.make_cast (l_time_0), create {CE_VOID_POINTER}.make_cast (((value) + 4)), (4).to_natural_32).do_nothing
			Result := (l_time_0.item)
		end

	timestamp_increment: INTEGER_32
		local
			l_increment: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_increment.make (<<1>>)

			memcpy (create {CE_VOID_POINTER}.make_cast (l_increment), create {CE_VOID_POINTER}.make_cast ((value)), (4).to_natural_32).do_nothing
			Result := (l_increment.item)
		end

	bool: INTEGER_32
		local
			l_pos: INTEGER_32
			l_return: BOOLEAN
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (type) -- switch 1 head
					when 8 then l_pos := -1 + 1
					when 16 then l_pos := -1 + 2
					when 18 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 4
					when 10 then l_pos := -1 + 5
					when 0 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 8u
					Result := (bool_raw)
					l_return := True
				when 2 then -- switch 1, case 16u
					if not l_return then
						Result := ((int_raw) /= 0).to_integer
						l_return := True
					end
				when 3 then -- switch 1, case 18u
					if not l_return then
						Result := ((long_raw) /= {INTEGER_64} 0).to_integer
						l_return := True
					end
				when 4 then -- switch 1, case 1u
					if not l_return then
						Result := ((double_raw) /= (0).to_double).to_integer
						l_return := True
					end
				when 5 then -- switch 1, case 10u | switch 1, case 0u
					if not l_return then
						Result := 0
						l_return := True
					end
				when 6 then -- switch 1, default:
					if not l_return then
						Result := 1
					end
				when 7 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	string: CE_POINTER [INTEGER_8]
		local
			l_pos: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_POINTER} Result.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (type) -- switch 1 head
					when 14 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 14u | switch 1, case 2u
					Result := ((value) + 4)
					l_return := True
				when 2 then -- switch 1, default:
					if not l_return then
						Result := (ce_cstring (""))
					end
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	date: INTEGER_64
		do
			Result := (long_raw)
		end

	time_t: INTEGER_32
		do
			Result := ((date) // {INTEGER_64} 1_000).to_integer_32
		end

	regex_opts: CE_POINTER [INTEGER_8]
		local
			l_p: CE_POINTER [INTEGER_8]
		do
			l_p := (value)
			Result := ((l_p + (strlen (l_p)).to_integer_32) + 1)
		end

	subiterator (a_sub: CE_POINTER [PD_BSON_ITERATOR])
		require
			not a_sub.is_void
		do
			a_sub.item.from_buffer ((value))
		end

feature {PD_BSON_ITERATOR} -- private routines

	bson_numstr (a_str: CE_POINTER [INTEGER_8]; a_i: INTEGER_32)
		do
			if a_i < 1_000 then
				memcpy (create {CE_VOID_POINTER}.make_cast (a_str), create {CE_VOID_POINTER}.make_cast ((bson_numstrs.item[a_i])), (4).to_natural_32).do_nothing
			else
				(create {P_SRC_BSON_STATIC}).bson_sprintf.item.call ([a_str, ce_cstring ("%%d"), a_i])
			end
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_bson_iterator_10);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_bson_iterator_10);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__cur (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_bson_iterator_10 *)$a_c_pointer)->cur;"
		end

	c__first (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_bson_iterator_10 *)$a_c_pointer)->first;"
		end

	c__set_cur (a_c_pointer: POINTER; a_cur: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_bson_iterator_10 *)$a_c_pointer)->cur = $a_cur;"
		end

	c__set_first (a_c_pointer: POINTER; a_first: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_bson_iterator_10 *)$a_c_pointer)->first = $a_first;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "cur") == 0) return offsetof(struct __anonstruct_bson_iterator_10, cur);
				if(strcmp($a_field_name, "first") == 0) return offsetof(struct __anonstruct_bson_iterator_10, first);
				fprintf(stderr, "struct __anonstruct_bson_iterator_10.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
