class
	PD_BSON_TIMESTAMP_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_i: INTEGER_32
				a_t: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.i := a_data.a_i
			Current.t := a_data.a_t
		end

feature {ANY} -- fields

	i: INTEGER_32 assign set__i
		do
			Result := c__i (internal_c_pointer)
		end

	t: INTEGER_32 assign set__t
		do
			Result := c__t (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__i (a_i: INTEGER_32)
		do
			c__set_i (internal_c_pointer, a_i)
		end

	set__t (a_t: INTEGER_32)
		do
			c__set_t (internal_c_pointer, a_t)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_bson_timestamp_t_13);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_bson_timestamp_t_13);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__i (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_bson_timestamp_t_13 *)$a_c_pointer)->i;"
		end

	c__t (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_bson_timestamp_t_13 *)$a_c_pointer)->t;"
		end

	c__set_i (a_c_pointer: POINTER; a_i: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_bson_timestamp_t_13 *)$a_c_pointer)->i = $a_i;"
		end

	c__set_t (a_c_pointer: POINTER; a_t: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_bson_timestamp_t_13 *)$a_c_pointer)->t = $a_t;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "i") == 0) return offsetof(struct __anonstruct_bson_timestamp_t_13, i);
				if(strcmp($a_field_name, "t") == 0) return offsetof(struct __anonstruct_bson_timestamp_t_13, t);
				fprintf(stderr, "struct __anonstruct_bson_timestamp_t_13.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
