class
	PD_MONGO_MD5_STATE_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_count: CE_ARRAY [NATURAL_32]
				a_abcd: CE_ARRAY [NATURAL_32]
				a_buf: CE_ARRAY [NATURAL_8]
			])
		require else
			a_data /= Void
		do
			make
			count.c_pointer.memory_copy (a_data.a_count.c_pointer, a_data.a_count.total_count * a_data.a_count.element_size)
			abcd.c_pointer.memory_copy (a_data.a_abcd.c_pointer, a_data.a_abcd.total_count * a_data.a_abcd.element_size)
			buf.c_pointer.memory_copy (a_data.a_buf.c_pointer, a_data.a_buf.total_count * a_data.a_buf.element_size)
		end

feature {ANY} -- fields

	count: CE_ARRAY [NATURAL_32]
		once ("OBJECT")
			create {CE_NATURAL_32_ARRAY} Result.make_shared (c__count (internal_c_pointer), <<2>>)
		end

	abcd: CE_ARRAY [NATURAL_32]
		once ("OBJECT")
			create {CE_NATURAL_32_ARRAY} Result.make_shared (c__abcd (internal_c_pointer), <<4>>)
		end

	buf: CE_ARRAY [NATURAL_8]
		once ("OBJECT")
			create {CE_NATURAL_8_ARRAY} Result.make_shared (c__buf (internal_c_pointer), <<64>>)
		end

feature {PD_MONGO_MD5_STATE_S} -- private attributes

	pad: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			create Result.make (create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
				>>))
		end

feature {ANY} -- public routines

	mongo_md5_process (a_data_0: CE_POINTER [NATURAL_8])
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_c: NATURAL_32
			l_d: NATURAL_32
			l_t: NATURAL_32
			l_xbuf: CE_ARRAY [NATURAL_32]
			l_x: CE_POINTER [NATURAL_32]
		do
			create {CE_NATURAL_32_ARRAY} l_xbuf.make (<<16>>)

			l_a := abcd[0]
			l_b := abcd[1]
			l_c := abcd[2]
			l_d := abcd[3]
			if not (((a_data_0.distance ((create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))))).bit_and (3)).to_boolean then
				l_x := create {CE_NATURAL_32_POINTER}.make_cast (a_data_0)
			else
				memcpy (create {CE_VOID_POINTER}.make_cast (l_xbuf), create {CE_VOID_POINTER}.make_cast (a_data_0), (64).to_natural_32).do_nothing
				l_x := create {CE_NATURAL_32_POINTER}.make_cast (l_xbuf)
			end
			l_t := ((l_a + ((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d))))) + l_x[0]) + {NATURAL_32} 3_614_090_360
			l_a := ((((l_t).bit_shift_left (7))).bit_or (((l_t).bit_shift_right (25)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c))))) + l_x[1]) + {NATURAL_32} 3_905_402_710
			l_d := ((((l_t).bit_shift_left (12))).bit_or (((l_t).bit_shift_right (20)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b))))) + l_x[2]) + {NATURAL_32} 606_105_819
			l_c := ((((l_t).bit_shift_left (17))).bit_or (((l_t).bit_shift_right (15)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a))))) + l_x[3]) + {NATURAL_32} 3_250_441_966
			l_b := ((((l_t).bit_shift_left (22))).bit_or (((l_t).bit_shift_right (10)))) + l_c
			l_t := ((l_a + ((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d))))) + l_x[4]) + {NATURAL_32} 4_118_548_399
			l_a := ((((l_t).bit_shift_left (7))).bit_or (((l_t).bit_shift_right (25)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c))))) + l_x[5]) + {NATURAL_32} 1_200_080_426
			l_d := ((((l_t).bit_shift_left (12))).bit_or (((l_t).bit_shift_right (20)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b))))) + l_x[6]) + {NATURAL_32} 2_821_735_955
			l_c := ((((l_t).bit_shift_left (17))).bit_or (((l_t).bit_shift_right (15)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a))))) + l_x[7]) + {NATURAL_32} 4_249_261_313
			l_b := ((((l_t).bit_shift_left (22))).bit_or (((l_t).bit_shift_right (10)))) + l_c
			l_t := ((l_a + ((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d))))) + l_x[8]) + {NATURAL_32} 1_770_035_416
			l_a := ((((l_t).bit_shift_left (7))).bit_or (((l_t).bit_shift_right (25)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c))))) + l_x[9]) + {NATURAL_32} 2_336_552_879
			l_d := ((((l_t).bit_shift_left (12))).bit_or (((l_t).bit_shift_right (20)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b))))) + l_x[10]) + {NATURAL_32} 4_294_925_233
			l_c := ((((l_t).bit_shift_left (17))).bit_or (((l_t).bit_shift_right (15)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a))))) + l_x[11]) + {NATURAL_32} 2_304_563_134
			l_b := ((((l_t).bit_shift_left (22))).bit_or (((l_t).bit_shift_right (10)))) + l_c
			l_t := ((l_a + ((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d))))) + l_x[12]) + {NATURAL_32} 1_804_603_682
			l_a := ((((l_t).bit_shift_left (7))).bit_or (((l_t).bit_shift_right (25)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c))))) + l_x[13]) + {NATURAL_32} 4_254_626_195
			l_d := ((((l_t).bit_shift_left (12))).bit_or (((l_t).bit_shift_right (20)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b))))) + l_x[14]) + {NATURAL_32} 2_792_965_006
			l_c := ((((l_t).bit_shift_left (17))).bit_or (((l_t).bit_shift_right (15)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a))))) + l_x[15]) + {NATURAL_32} 1_236_535_329
			l_b := ((((l_t).bit_shift_left (22))).bit_or (((l_t).bit_shift_right (10)))) + l_c
			l_t := ((l_a + ((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not))))) + l_x[1]) + {NATURAL_32} 4_129_170_786
			l_a := ((((l_t).bit_shift_left (5))).bit_or (((l_t).bit_shift_right (27)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not))))) + l_x[6]) + {NATURAL_32} 3_225_465_664
			l_d := ((((l_t).bit_shift_left (9))).bit_or (((l_t).bit_shift_right (23)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not))))) + l_x[11]) + {NATURAL_32} 643_717_713
			l_c := ((((l_t).bit_shift_left (14))).bit_or (((l_t).bit_shift_right (18)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not))))) + l_x[0]) + {NATURAL_32} 3_921_069_994
			l_b := ((((l_t).bit_shift_left (20))).bit_or (((l_t).bit_shift_right (12)))) + l_c
			l_t := ((l_a + ((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not))))) + l_x[5]) + {NATURAL_32} 3_593_408_605
			l_a := ((((l_t).bit_shift_left (5))).bit_or (((l_t).bit_shift_right (27)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not))))) + l_x[10]) + {NATURAL_32} 38_016_083
			l_d := ((((l_t).bit_shift_left (9))).bit_or (((l_t).bit_shift_right (23)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not))))) + l_x[15]) + {NATURAL_32} 3_634_488_961
			l_c := ((((l_t).bit_shift_left (14))).bit_or (((l_t).bit_shift_right (18)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not))))) + l_x[4]) + {NATURAL_32} 3_889_429_448
			l_b := ((((l_t).bit_shift_left (20))).bit_or (((l_t).bit_shift_right (12)))) + l_c
			l_t := ((l_a + ((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not))))) + l_x[9]) + {NATURAL_32} 568_446_438
			l_a := ((((l_t).bit_shift_left (5))).bit_or (((l_t).bit_shift_right (27)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not))))) + l_x[14]) + {NATURAL_32} 3_275_163_606
			l_d := ((((l_t).bit_shift_left (9))).bit_or (((l_t).bit_shift_right (23)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not))))) + l_x[3]) + {NATURAL_32} 4_107_603_335
			l_c := ((((l_t).bit_shift_left (14))).bit_or (((l_t).bit_shift_right (18)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not))))) + l_x[8]) + {NATURAL_32} 1_163_531_501
			l_b := ((((l_t).bit_shift_left (20))).bit_or (((l_t).bit_shift_right (12)))) + l_c
			l_t := ((l_a + ((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not))))) + l_x[13]) + {NATURAL_32} 2_850_285_829
			l_a := ((((l_t).bit_shift_left (5))).bit_or (((l_t).bit_shift_right (27)))) + l_b
			l_t := ((l_d + ((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not))))) + l_x[2]) + {NATURAL_32} 4_243_563_512
			l_d := ((((l_t).bit_shift_left (9))).bit_or (((l_t).bit_shift_right (23)))) + l_a
			l_t := ((l_c + ((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not))))) + l_x[7]) + {NATURAL_32} 1_735_328_473
			l_c := ((((l_t).bit_shift_left (14))).bit_or (((l_t).bit_shift_right (18)))) + l_d
			l_t := ((l_b + ((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not))))) + l_x[12]) + {NATURAL_32} 2_368_359_562
			l_b := ((((l_t).bit_shift_left (20))).bit_or (((l_t).bit_shift_right (12)))) + l_c
			l_t := ((l_a + ((((l_b).bit_xor (l_c))).bit_xor (l_d))) + l_x[5]) + {NATURAL_32} 4_294_588_738
			l_a := ((((l_t).bit_shift_left (4))).bit_or (((l_t).bit_shift_right (28)))) + l_b
			l_t := ((l_d + ((((l_a).bit_xor (l_b))).bit_xor (l_c))) + l_x[8]) + {NATURAL_32} 2_272_392_833
			l_d := ((((l_t).bit_shift_left (11))).bit_or (((l_t).bit_shift_right (21)))) + l_a
			l_t := ((l_c + ((((l_d).bit_xor (l_a))).bit_xor (l_b))) + l_x[11]) + {NATURAL_32} 1_839_030_562
			l_c := ((((l_t).bit_shift_left (16))).bit_or (((l_t).bit_shift_right (16)))) + l_d
			l_t := ((l_b + ((((l_c).bit_xor (l_d))).bit_xor (l_a))) + l_x[14]) + {NATURAL_32} 4_259_657_740
			l_b := ((((l_t).bit_shift_left (23))).bit_or (((l_t).bit_shift_right (9)))) + l_c
			l_t := ((l_a + ((((l_b).bit_xor (l_c))).bit_xor (l_d))) + l_x[1]) + {NATURAL_32} 2_763_975_236
			l_a := ((((l_t).bit_shift_left (4))).bit_or (((l_t).bit_shift_right (28)))) + l_b
			l_t := ((l_d + ((((l_a).bit_xor (l_b))).bit_xor (l_c))) + l_x[4]) + {NATURAL_32} 1_272_893_353
			l_d := ((((l_t).bit_shift_left (11))).bit_or (((l_t).bit_shift_right (21)))) + l_a
			l_t := ((l_c + ((((l_d).bit_xor (l_a))).bit_xor (l_b))) + l_x[7]) + {NATURAL_32} 4_139_469_664
			l_c := ((((l_t).bit_shift_left (16))).bit_or (((l_t).bit_shift_right (16)))) + l_d
			l_t := ((l_b + ((((l_c).bit_xor (l_d))).bit_xor (l_a))) + l_x[10]) + {NATURAL_32} 3_200_236_656
			l_b := ((((l_t).bit_shift_left (23))).bit_or (((l_t).bit_shift_right (9)))) + l_c
			l_t := ((l_a + ((((l_b).bit_xor (l_c))).bit_xor (l_d))) + l_x[13]) + {NATURAL_32} 681_279_174
			l_a := ((((l_t).bit_shift_left (4))).bit_or (((l_t).bit_shift_right (28)))) + l_b
			l_t := ((l_d + ((((l_a).bit_xor (l_b))).bit_xor (l_c))) + l_x[0]) + {NATURAL_32} 3_936_430_074
			l_d := ((((l_t).bit_shift_left (11))).bit_or (((l_t).bit_shift_right (21)))) + l_a
			l_t := ((l_c + ((((l_d).bit_xor (l_a))).bit_xor (l_b))) + l_x[3]) + {NATURAL_32} 3_572_445_317
			l_c := ((((l_t).bit_shift_left (16))).bit_or (((l_t).bit_shift_right (16)))) + l_d
			l_t := ((l_b + ((((l_c).bit_xor (l_d))).bit_xor (l_a))) + l_x[6]) + {NATURAL_32} 76_029_189
			l_b := ((((l_t).bit_shift_left (23))).bit_or (((l_t).bit_shift_right (9)))) + l_c
			l_t := ((l_a + ((((l_b).bit_xor (l_c))).bit_xor (l_d))) + l_x[9]) + {NATURAL_32} 3_654_602_809
			l_a := ((((l_t).bit_shift_left (4))).bit_or (((l_t).bit_shift_right (28)))) + l_b
			l_t := ((l_d + ((((l_a).bit_xor (l_b))).bit_xor (l_c))) + l_x[12]) + {NATURAL_32} 3_873_151_461
			l_d := ((((l_t).bit_shift_left (11))).bit_or (((l_t).bit_shift_right (21)))) + l_a
			l_t := ((l_c + ((((l_d).bit_xor (l_a))).bit_xor (l_b))) + l_x[15]) + {NATURAL_32} 530_742_520
			l_c := ((((l_t).bit_shift_left (16))).bit_or (((l_t).bit_shift_right (16)))) + l_d
			l_t := ((l_b + ((((l_c).bit_xor (l_d))).bit_xor (l_a))) + l_x[2]) + {NATURAL_32} 3_299_628_645
			l_b := ((((l_t).bit_shift_left (23))).bit_or (((l_t).bit_shift_right (9)))) + l_c
			l_t := ((l_a + ((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not))))) + l_x[0]) + {NATURAL_32} 4_096_336_452
			l_a := ((((l_t).bit_shift_left (6))).bit_or (((l_t).bit_shift_right (26)))) + l_b
			l_t := ((l_d + ((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not))))) + l_x[7]) + {NATURAL_32} 1_126_891_415
			l_d := ((((l_t).bit_shift_left (10))).bit_or (((l_t).bit_shift_right (22)))) + l_a
			l_t := ((l_c + ((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not))))) + l_x[14]) + {NATURAL_32} 2_878_612_391
			l_c := ((((l_t).bit_shift_left (15))).bit_or (((l_t).bit_shift_right (17)))) + l_d
			l_t := ((l_b + ((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not))))) + l_x[5]) + {NATURAL_32} 4_237_533_241
			l_b := ((((l_t).bit_shift_left (21))).bit_or (((l_t).bit_shift_right (11)))) + l_c
			l_t := ((l_a + ((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not))))) + l_x[12]) + {NATURAL_32} 1_700_485_571
			l_a := ((((l_t).bit_shift_left (6))).bit_or (((l_t).bit_shift_right (26)))) + l_b
			l_t := ((l_d + ((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not))))) + l_x[3]) + {NATURAL_32} 2_399_980_690
			l_d := ((((l_t).bit_shift_left (10))).bit_or (((l_t).bit_shift_right (22)))) + l_a
			l_t := ((l_c + ((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not))))) + l_x[10]) + {NATURAL_32} 4_293_915_773
			l_c := ((((l_t).bit_shift_left (15))).bit_or (((l_t).bit_shift_right (17)))) + l_d
			l_t := ((l_b + ((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not))))) + l_x[1]) + {NATURAL_32} 2_240_044_497
			l_b := ((((l_t).bit_shift_left (21))).bit_or (((l_t).bit_shift_right (11)))) + l_c
			l_t := ((l_a + ((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not))))) + l_x[8]) + {NATURAL_32} 1_873_313_359
			l_a := ((((l_t).bit_shift_left (6))).bit_or (((l_t).bit_shift_right (26)))) + l_b
			l_t := ((l_d + ((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not))))) + l_x[15]) + {NATURAL_32} 4_264_355_552
			l_d := ((((l_t).bit_shift_left (10))).bit_or (((l_t).bit_shift_right (22)))) + l_a
			l_t := ((l_c + ((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not))))) + l_x[6]) + {NATURAL_32} 2_734_768_916
			l_c := ((((l_t).bit_shift_left (15))).bit_or (((l_t).bit_shift_right (17)))) + l_d
			l_t := ((l_b + ((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not))))) + l_x[13]) + {NATURAL_32} 1_309_151_649
			l_b := ((((l_t).bit_shift_left (21))).bit_or (((l_t).bit_shift_right (11)))) + l_c
			l_t := ((l_a + ((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not))))) + l_x[4]) + {NATURAL_32} 4_149_444_226
			l_a := ((((l_t).bit_shift_left (6))).bit_or (((l_t).bit_shift_right (26)))) + l_b
			l_t := ((l_d + ((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not))))) + l_x[11]) + {NATURAL_32} 3_174_756_917
			l_d := ((((l_t).bit_shift_left (10))).bit_or (((l_t).bit_shift_right (22)))) + l_a
			l_t := ((l_c + ((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not))))) + l_x[2]) + {NATURAL_32} 718_787_259
			l_c := ((((l_t).bit_shift_left (15))).bit_or (((l_t).bit_shift_right (17)))) + l_d
			l_t := ((l_b + ((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not))))) + l_x[9]) + {NATURAL_32} 3_951_481_745
			l_b := ((((l_t).bit_shift_left (21))).bit_or (((l_t).bit_shift_right (11)))) + l_c
			abcd[0] := abcd[0] + l_a
			abcd[1] := abcd[1] + l_b
			abcd[2] := abcd[2] + l_c
			abcd[3] := abcd[3] + l_d
		end

	mongo_md5_init
		local
			l_tmp: NATURAL_32
		do
			l_tmp := (0).to_natural_32
			count[1] := l_tmp
			count[0] := l_tmp
			abcd[0] := (1_732_584_193).to_natural_32
			abcd[1] := {NATURAL_32} 4_023_233_417
			abcd[2] := {NATURAL_32} 2_562_383_102
			abcd[3] := (271_733_878).to_natural_32
		end

	mongo_md5_append (a_data_0: CE_POINTER [NATURAL_8]; a_nbytes: INTEGER_32)
		local
			l_p: CE_POINTER [NATURAL_8]
			l_left: INTEGER_32
			l_offset: INTEGER_32
			l_nbits: NATURAL_32
			l_copy: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_p := a_data_0
			l_left := a_nbytes
			l_offset := ((((count[0]).bit_shift_right (3))).bit_and ({NATURAL_32} 63)).to_integer_32
			l_nbits := ((a_nbytes).bit_shift_left (3)).to_natural_32
			if a_nbytes <= 0 then
				l_return := True
			end
			if not l_return then
				count[1] := count[1] + ((a_nbytes).bit_shift_right (29)).to_natural_32
				count[0] := count[0] + l_nbits
				if count[0] < l_nbits then
					count[1] := (count[1]) + 1
				end
				if l_offset.to_boolean then
					if l_offset + a_nbytes > 64 then
						l_tmp := 64 - l_offset
					else
						l_tmp := a_nbytes
					end
					l_copy := l_tmp
					memcpy (create {CE_VOID_POINTER}.make_cast ((buf + l_offset)), create {CE_VOID_POINTER}.make_cast (l_p), l_copy.to_natural_32).do_nothing
					if l_offset + l_copy < 64 then
						l_return := True
					end
					if not l_return then
						l_p := l_p + l_copy
						l_left := l_left - l_copy;
						((create {CE_CLASS_POINTER [PD_MONGO_MD5_STATE_S]}.make_shared (c_pointer))).item.mongo_md5_process (create {CE_NATURAL_8_POINTER}.make_cast (buf))
					end
				end
			end
			if not l_return then
				from
				until
					not (l_left >= 64)
				loop
					((create {CE_CLASS_POINTER [PD_MONGO_MD5_STATE_S]}.make_shared (c_pointer))).item.mongo_md5_process (l_p)
					l_p := l_p + (64)
					l_left := l_left - (64)
				end
				if l_left.to_boolean then
					memcpy (create {CE_VOID_POINTER}.make_cast (buf), create {CE_VOID_POINTER}.make_cast (l_p), l_left.to_natural_32).do_nothing
				end
			end
		end

	mongo_md5_finish (a_digest: CE_POINTER [NATURAL_8])
		local
			l_data_0: CE_ARRAY [NATURAL_8]
			l_i: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_data_0.make (<<8>>)

			l_i := 0
			from
			until
				not (l_i < 8)
			loop
				l_data_0[l_i] := ((count[(l_i).bit_shift_right (2)]).bit_shift_right (((((l_i).bit_and (3))).bit_shift_left (3)))).to_natural_8
				l_i := l_i + 1
			end
			((create {CE_CLASS_POINTER [PD_MONGO_MD5_STATE_S]}.make_shared (c_pointer))).item.mongo_md5_append (pad.item, (((({NATURAL_32} 55 - ((count[0]).bit_shift_right (3)))).bit_and ({NATURAL_32} 63)) + {NATURAL_32} 1).to_integer_32);
			((create {CE_CLASS_POINTER [PD_MONGO_MD5_STATE_S]}.make_shared (c_pointer))).item.mongo_md5_append (create {CE_NATURAL_8_POINTER}.make_cast (l_data_0), 8)
			l_i := 0
			from
			until
				not (l_i < 16)
			loop
				a_digest[l_i] := ((abcd[(l_i).bit_shift_right (2)]).bit_shift_right (((((l_i).bit_and (3))).bit_shift_left (3)))).to_natural_8
				l_i := l_i + 1
			end
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct mongo_md5_state_s);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct mongo_md5_state_s);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__count (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo_md5_state_s *)$a_c_pointer)->count;"
		end

	c__abcd (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo_md5_state_s *)$a_c_pointer)->abcd;"
		end

	c__buf (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo_md5_state_s *)$a_c_pointer)->buf;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "count") == 0) return offsetof(struct mongo_md5_state_s, count);
				if(strcmp($a_field_name, "abcd") == 0) return offsetof(struct mongo_md5_state_s, abcd);
				if(strcmp($a_field_name, "buf") == 0) return offsetof(struct mongo_md5_state_s, buf);
				fprintf(stderr, "struct mongo_md5_state_s.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
