class
	PD_MONGO_REPLY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_head: PD_MONGO_HEADER
				a_fields: PD_MONGO_REPLY_FIELDS
				a_objs: INTEGER_8
			])
		require else
			a_data /= Void
		do
			make
			head.c_pointer.memory_copy (a_data.a_head.c_pointer, a_data.a_head.structure_size)
			fields.c_pointer.memory_copy (a_data.a_fields.c_pointer, a_data.a_fields.structure_size)
			Current.objs := a_data.a_objs
		end

feature {ANY} -- fields

	head: PD_MONGO_HEADER assign set__head
		once ("OBJECT")
			create Result.make_shared (c__head (internal_c_pointer))
		end

	fields: PD_MONGO_REPLY_FIELDS assign set__fields
		once ("OBJECT")
			create Result.make_shared (c__fields (internal_c_pointer))
		end

	objs: INTEGER_8 assign set__objs
		do
			Result := c__objs (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__head (a_head: PD_MONGO_HEADER)
		do
			c__set_head (internal_c_pointer, a_head.c_pointer)
		end

	set__fields (a_fields: PD_MONGO_REPLY_FIELDS)
		do
			c__set_fields (internal_c_pointer, a_fields.c_pointer)
		end

	set__objs (a_objs: INTEGER_8)
		do
			c__set_objs (internal_c_pointer, a_objs)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_mongo_reply_17);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_mongo_reply_17);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__head (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct_mongo_reply_17 *)$a_c_pointer)->head;"
		end

	c__fields (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct_mongo_reply_17 *)$a_c_pointer)->fields;"
		end

	c__objs (a_c_pointer: POINTER): INTEGER_8
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_reply_17 *)$a_c_pointer)->objs;"
		end

	c__set_head (a_c_pointer: POINTER; a_head: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_reply_17 *)$a_c_pointer)->head = *(struct __anonstruct_mongo_header_14 *)$a_head;"
		end

	c__set_fields (a_c_pointer: POINTER; a_fields: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_reply_17 *)$a_c_pointer)->fields = *(struct __anonstruct_mongo_reply_fields_16 *)$a_fields;"
		end

	c__set_objs (a_c_pointer: POINTER; a_objs: INTEGER_8)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_reply_17 *)$a_c_pointer)->objs = $a_objs;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "head") == 0) return offsetof(struct __anonstruct_mongo_reply_17, head);
				if(strcmp($a_field_name, "fields") == 0) return offsetof(struct __anonstruct_mongo_reply_17, fields);
				if(strcmp($a_field_name, "objs") == 0) return offsetof(struct __anonstruct_mongo_reply_17, objs);
				fprintf(stderr, "struct __anonstruct_mongo_reply_17.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
