class
	PD_MONGO_REPLY_FIELDS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_flag: INTEGER_32
				a_cursor_id: INTEGER_64
				a_start: INTEGER_32
				a_num: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.flag := a_data.a_flag
			Current.cursor_id := a_data.a_cursor_id
			Current.start := a_data.a_start
			Current.num := a_data.a_num
		end

feature {ANY} -- fields

	flag: INTEGER_32 assign set__flag
		do
			Result := c__flag (internal_c_pointer)
		end

	cursor_id: INTEGER_64 assign set__cursor_id
		do
			Result := c__cursor_id (internal_c_pointer)
		end

	start: INTEGER_32 assign set__start
		do
			Result := c__start (internal_c_pointer)
		end

	num: INTEGER_32 assign set__num
		do
			Result := c__num (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__flag (a_flag: INTEGER_32)
		do
			c__set_flag (internal_c_pointer, a_flag)
		end

	set__cursor_id (a_cursor_id: INTEGER_64)
		do
			c__set_cursor_id (internal_c_pointer, a_cursor_id)
		end

	set__start (a_start: INTEGER_32)
		do
			c__set_start (internal_c_pointer, a_start)
		end

	set__num (a_num: INTEGER_32)
		do
			c__set_num (internal_c_pointer, a_num)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_mongo_reply_fields_16);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_mongo_reply_fields_16);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__flag (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->flag;"
		end

	c__cursor_id (a_c_pointer: POINTER): INTEGER_64
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->cursorID;"
		end

	c__start (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->start;"
		end

	c__num (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->num;"
		end

	c__set_flag (a_c_pointer: POINTER; a_flag: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->flag = $a_flag;"
		end

	c__set_cursor_id (a_c_pointer: POINTER; a_cursor_id: INTEGER_64)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->cursorID = $a_cursor_id;"
		end

	c__set_start (a_c_pointer: POINTER; a_start: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->start = $a_start;"
		end

	c__set_num (a_c_pointer: POINTER; a_num: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_reply_fields_16 *)$a_c_pointer)->num = $a_num;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "flag") == 0) return offsetof(struct __anonstruct_mongo_reply_fields_16, flag);
				if(strcmp($a_field_name, "cursor_id") == 0) return offsetof(struct __anonstruct_mongo_reply_fields_16, cursorID);
				if(strcmp($a_field_name, "start") == 0) return offsetof(struct __anonstruct_mongo_reply_fields_16, start);
				if(strcmp($a_field_name, "num") == 0) return offsetof(struct __anonstruct_mongo_reply_fields_16, num);
				fprintf(stderr, "struct __anonstruct_mongo_reply_fields_16.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
