class
	S_STDLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	atoi (a_str: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atoi (a_str.c_pointer)
		end

	c_atoi (a_str: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return atoi($a_str);"
		end

	rand: INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return rand();"
		end

	free (a_memory: CE_POINTER [ANY])
		do
			c_free (a_memory.c_pointer)
		end

	c_free (a_memory: POINTER)
		external
			"C inline use <libmongo.h>"
		alias
			"free($a_memory);"
		end

	exit (a_code: INTEGER_32)
		external
			"C inline use <libmongo.h>"
		alias
			"exit($a_code);"
		ensure
			False
		end

	srand (a_seed: NATURAL_32)
		external
			"C inline use <libmongo.h>"
		alias
			"srand($a_seed);"
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

feature {ANY} -- routine addresses

	free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent free)
		end

	malloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent malloc)
		end

	realloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent realloc)
		end

end
