class
	S_WINSOCK2_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	closesocket (a_s: NATURAL_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return closesocket($a_s);"
		end

	connect (a_s: NATURAL_32; a_name: CE_POINTER [SD_SOCKADDR]; a_namelen: INTEGER_32): INTEGER_32
		do
			Result := c_connect (a_s, a_name.c_pointer, a_namelen)
		end

	c_connect (a_s: NATURAL_32; a_name: POINTER; a_namelen: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return connect($a_s, $a_name, $a_namelen);"
		end

	recv (a_s: NATURAL_32; a_buf: CE_POINTER [INTEGER_8]; a_len, a_flags: INTEGER_32): INTEGER_32
		do
			Result := c_recv (a_s, a_buf.c_pointer, a_len, a_flags)
		end

	c_recv (a_s: NATURAL_32; a_buf: POINTER; a_len: INTEGER_32; a_flags: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return recv($a_s, $a_buf, $a_len, $a_flags);"
		end

	send (a_s: NATURAL_32; a_buf: CE_POINTER [INTEGER_8]; a_len, a_flags: INTEGER_32): INTEGER_32
		do
			Result := c_send (a_s, a_buf.c_pointer, a_len, a_flags)
		end

	c_send (a_s: NATURAL_32; a_buf: POINTER; a_len: INTEGER_32; a_flags: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return send($a_s, $a_buf, $a_len, $a_flags);"
		end

	setsockopt (a_s: NATURAL_32; a_level, a_optname: INTEGER_32; a_optval: CE_POINTER [INTEGER_8]; a_optlen: INTEGER_32): INTEGER_32
		do
			Result := c_setsockopt (a_s, a_level, a_optname, a_optval.c_pointer, a_optlen)
		end

	c_setsockopt (a_s: NATURAL_32; a_level: INTEGER_32; a_optname: INTEGER_32; a_optval: POINTER; a_optlen: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return setsockopt($a_s, $a_level, $a_optname, $a_optval, $a_optlen);"
		end

	socket (a_af: INTEGER_32; a_type: INTEGER_32; a_protocol: INTEGER_32): NATURAL_32
		external
			"C inline use <libmongo.h>"
		alias
			"return socket($a_af, $a_type, $a_protocol);"
		end

	wsastartup (a_w_version_requested: NATURAL_16; a_lp_wsadata: CE_POINTER [SD_WSADATA]): INTEGER_32
		do
			Result := c_wsastartup (a_w_version_requested, a_lp_wsadata.c_pointer)
		end

	c_wsastartup (a_w_version_requested: NATURAL_16; a_lp_wsadata: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return WSAStartup($a_w_version_requested, $a_lp_wsadata);"
		end

	wsaget_last_error: INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return WSAGetLastError();"
		end

end
