class
	SD_SOCKADDR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_sa_family: NATURAL_16
				a_sa_data: CE_ARRAY [INTEGER_8]
			])
		require else
			a_data /= Void
		do
			make
			Current.sa_family := a_data.a_sa_family
			sa_data.c_pointer.memory_copy (a_data.a_sa_data.c_pointer, a_data.a_sa_data.total_count * a_data.a_sa_data.element_size)
		end

feature {ANY} -- fields

	sa_family: NATURAL_16 assign set__sa_family
		do
			Result := c__sa_family (internal_c_pointer)
		end

	sa_data: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__sa_data (internal_c_pointer), <<14>>)
		end

feature {ANY} -- field setters

	set__sa_family (a_sa_family: NATURAL_16)
		do
			c__set_sa_family (internal_c_pointer, a_sa_family)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct sockaddr);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct sockaddr);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__sa_family (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct sockaddr *)$a_c_pointer)->sa_family;"
		end

	c__sa_data (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct sockaddr *)$a_c_pointer)->sa_data;"
		end

	c__set_sa_family (a_c_pointer: POINTER; a_sa_family: NATURAL_16)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct sockaddr *)$a_c_pointer)->sa_family = $a_sa_family;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "sa_family") == 0) return offsetof(struct sockaddr, sa_family);
				if(strcmp($a_field_name, "sa_data") == 0) return offsetof(struct sockaddr, sa_data);
				fprintf(stderr, "struct sockaddr.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
